unit VTColumnsDemo;

                                        interface
//----------------------------------------------------------------------------------------------------------------------
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ImgList, VirtualTrees;
//----------------------------------------------------------------------------------------------------------------------


type
  TfrmVTColumns = class(TForm)
    VTColumns: TVirtualStringTree;
    procedure VTColumnsGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: WideString);
    procedure FormCreate(Sender: TObject);
  private
    //
  public
    //
  end;

var frmVTColumns: TfrmVTColumns;

                                         implementation
//----------------------------------------------------------------------------------------------------------------------
{$R *.dfm}


type
  PGridData = ^TGridData;
  TGridData = record
    Value: array[0..2] of Variant;
  end;


//you can also fill data on InitNode event
//----------------------------------------------------------------------------------------------------------------------
procedure TfrmVTColumns.FormCreate(Sender: TObject);
var vNode : PVirtualNode;
    Data: PGridData;
begin
  VTColumns.NodeDataSize := SizeOf(TGridData);

  vNode := VTColumns.GetFirst;
  While vNode <> nil do begin
    Data := VTColumns.GetNodeData(vNode);
    Data.Value[0] := Variant(vNode.Index);
    Data.Value[1] := 'Apple';
    Data.Value[2] := Date;

    vNode := VTColumns.GetNext(vNode);
  end;

end;

//----------------------------------------------------------------------------------------------------------------------
procedure TfrmVTColumns.VTColumnsGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex;
  TextType: TVSTTextType; var CellText: WideString);
var Data: PGridData;
begin
  if Column > 0 then begin
    Data := Sender.GetNodeData(Node);
    CellText := Data.Value[Column - 1];
  end else
    CellText := '';
end;

end.
